# !/usr/bin/env python3
# -*- coding: utf-8 -*-

"""
Created by:         Lukas E. G. Fischer
                    Methods Center • University of Tübingen
                    lukas.fischer@uni-tuebingen.de • https://uni-tuebingen.de/en/203347
Created on:         13.03.2021

This function returns a function which formats numbers according to the specified string operations.

Inputs
    - precision:        integer -> accuracy to be shown (e.g. number of decimal places if format type is "f" or number
                        of significant digits if format type is "g")
    - num_format:       string -> format type
"""

from functools import partial


def format_num(precision, num_format):
    def create_formatter(num, inner_prec, inner_form):
        return "{:.{}{}}".format(num, inner_prec, inner_form)
    return partial(create_formatter, inner_prec=precision, inner_form=num_format)
